ompi/mca/pml/ob1/pml_ob1_recvfrag.c File Reference.TH "ompi/mca/pml/ob1/pml_ob1_recvfrag.c" 3 "7 Dec 2005" "Version 0.1.1" "OpenMPI" \" -*- nroff -*-
.ad l
.nh
.SH NAME
ompi/mca/pml/ob1/pml_ob1_recvfrag.c \- 
.SH SYNOPSIS
.br
.PP
\fC#include 'ompi_config.h'\fP
.br
\fC#include 'opal/class/opal_list.h'\fP
.br
\fC#include 'opal/threads/mutex.h'\fP
.br
\fC#include 'ompi/include/constants.h'\fP
.br
\fC#include 'communicator/communicator.h'\fP
.br
\fC#include 'mca/pml/pml.h'\fP
.br
\fC#include 'pml_ob1.h'\fP
.br
\fC#include 'pml_ob1_comm.h'\fP
.br
\fC#include 'pml_ob1_recvfrag.h'\fP
.br
\fC#include 'pml_ob1_recvreq.h'\fP
.br
\fC#include 'pml_ob1_sendreq.h'\fP
.br
\fC#include 'pml_ob1_hdr.h'\fP
.br

.SS "Defines"

.in +1c
.ti -1c
.RI "#define \fBMCA_PML_OB1_CHECK_WILD_RECEIVES_FOR_MATCH\fP(hdr, comm, proc, return_match)"
.br
.RI "\fITry and match the incoming message fragment to the list of 'wild' receives. \fP"
.ti -1c
.RI "#define \fBMCA_PML_OB1_CHECK_SPECIFIC_RECEIVES_FOR_MATCH\fP(hdr, comm, proc, return_match)"
.br
.RI "\fITry and match the incoming message fragment to the list of 'specific' receives. \fP"
.ti -1c
.RI "#define \fBMCA_PML_OB1_CHECK_SPECIFIC_AND_WILD_RECEIVES_FOR_MATCH\fP(hdr, comm, proc, return_match)"
.br
.RI "\fITry and match the incoming message fragment to the list of 'wild' receives and 'specific' receives. \fP"
.in -1c
.SS "Functions"

.in +1c
.ti -1c
.RI "\fBOBJ_CLASS_INSTANCE\fP (mca_pml_ob1_buffer_t, \fBopal_list_item_t\fP, NULL, NULL)"
.br
.ti -1c
.RI "\fBOBJ_CLASS_INSTANCE\fP (mca_pml_ob1_recv_frag_t, \fBopal_list_item_t\fP, NULL, NULL)"
.br
.ti -1c
.RI "void \fBmca_pml_ob1_recv_frag_callback\fP (\fBmca_btl_base_module_t\fP *btl, mca_btl_base_tag_t tag, \fBmca_btl_base_descriptor_t\fP *des, void *cbdata)"
.br
.RI "\fICallback from BTL on receipt of a recv_frag. \fP"
.ti -1c
.RI "static bool \fBmca_pml_ob1_check_cantmatch_for_match\fP (\fBopal_list_t\fP *additional_matches, \fBmca_pml_ob1_comm_t\fP *comm, mca_pml_ob1_comm_proc_t *proc)"
.br
.RI "\fIScan the list of frags that came in ahead of time to see if any can be processed at this time. \fP"
.ti -1c
.RI "int \fBmca_pml_ob1_recv_frag_match\fP (\fBmca_btl_base_module_t\fP *btl, \fBmca_pml_ob1_match_hdr_t\fP *hdr, \fBmca_btl_base_segment_t\fP *segments, size_t num_segments)"
.br
.RI "\fIMatch incoming recv_frags against posted receives. \fP"
.in -1c
.SH "Detailed Description"
.PP 

.SH "Define Documentation"
.PP 
.SS "#define MCA_PML_OB1_CHECK_SPECIFIC_AND_WILD_RECEIVES_FOR_MATCH(hdr, comm, proc, return_match)"
.PP
Try and match the incoming message fragment to the list of 'wild' receives and 'specific' receives. 
.PP
Used when both types of receives have been posted, i.e. when we need to coordinate between multiple lists to make sure ordered delivery occurs.
.PP
\fBParameters:\fP
.RS 4
\fIhdr\fP Matching data from recived fragment (IN)
.br
\fIcomm\fP Pointer to the communicator structure used for matching purposes. (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Matched receive
.RE
.PP
This routine assumes that the appropriate matching locks are set by the upper level routine. 
.SS "#define MCA_PML_OB1_CHECK_SPECIFIC_RECEIVES_FOR_MATCH(hdr, comm, proc, return_match)"
.PP
Try and match the incoming message fragment to the list of 'specific' receives. 
.PP
\fBParameters:\fP
.RS 4
\fIhdr\fP Matching data from recived fragment (IN)
.br
\fIcomm\fP Pointer to the communicator structure used for matching purposes. (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Matched receive
.RE
.PP
This routine assumes that the appropriate matching locks are set by the upper level routine. 
.SS "#define MCA_PML_OB1_CHECK_WILD_RECEIVES_FOR_MATCH(hdr, comm, proc, return_match)"
.PP
Try and match the incoming message fragment to the list of 'wild' receives. 
.PP
\fBParameters:\fP
.RS 4
\fIhdr\fP Matching data from recived fragment (IN)
.br
\fIpml_comm\fP Pointer to the communicator structure used for matching purposes. (IN)
.RE
.PP
\fBReturns:\fP
.RS 4
Matched receive
.RE
.PP
This routine assumes that the appropriate matching locks are set by the upper level routine. 
.SH "Function Documentation"
.PP 
.SS "static bool mca_pml_ob1_check_cantmatch_for_match (\fBopal_list_t\fP * additional_matches, \fBmca_pml_ob1_comm_t\fP * comm, mca_pml_ob1_comm_proc_t * proc)\fC [static]\fP"
.PP
Scan the list of frags that came in ahead of time to see if any can be processed at this time. 
.PP
If they can, try and match the frags.
.PP
\fBParameters:\fP
.RS 4
\fIadditional_matches\fP List to hold new matches with fragments from the c_frags_cant_match list. (IN/OUT)
.br
\fIpml_comm\fP Pointer to the communicator structure used for matching purposes. (IN)
.RE
.PP
This routine assumes that the appropriate matching locks are set by the upper level routine. 
.SS "int mca_pml_ob1_recv_frag_match (\fBmca_btl_base_module_t\fP * btl, \fBmca_pml_ob1_match_hdr_t\fP * hdr, \fBmca_btl_base_segment_t\fP * segments, size_t num_segments)"
.PP
Match incoming recv_frags against posted receives. 
.PP
\fBParameters:\fP
.RS 4
\fIhdr\fP list of parameters needed for matching This list is also embeded in frag, but this allows to save a memory copy when a match is made in this routine. (IN) 
.br
\fIfrag\fP pointer to receive fragment which we want to match (IN/OUT). If a match is not made, hdr is copied to frag. 
.br
\fImatch_made\fP parameter indicating if we matched frag/ hdr (OUT) 
.br
\fIadditional_matches\fP if a match is made with frag, we may be able to match fragments that previously have arrived out-of-order. If this is the case, the associated fragment descriptors are put on this list for further processing. (OUT)
.RE
.PP
\fBReturns:\fP
.RS 4
OMPI error code
.RE
.PP
This routine is used to try and match a newly arrived message fragment to pre-posted receives. The following assumptions are made
.IP "\(bu" 2
fragments are received out of order
.IP "\(bu" 2
for long messages, e.g. more than one fragment, a RTS/CTS algorithm is used.
.IP "\(bu" 2
2nd and greater fragments include a receive descriptor pointer
.IP "\(bu" 2
fragments may be dropped
.IP "\(bu" 2
fragments may be corrupt
.IP "\(bu" 2
this routine may be called simultaneously by more than one thread 
.PP

.SH "Author"
.PP 
Generated automatically by Doxygen for OpenMPI from the source code.
